/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package buddhabrot;

import java.util.Date;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author zerjillo
 */
public class BuddhabrotPoster {

    int[][] image;
    int pw;
    int ph;
    double scale;
    int maxIter;
    double pixelWidth;
    double minX;
    double minY;
    double maxX;
    double maxY;
    String name;
    String format;
    long maxTotalCount;
    int nThreads;

    public BuddhabrotPoster(int pw, int ph, double scale, int maxIter, String name, String format, long maxTotalCount, int nThreads) {
        this.pw = pw;
        this.ph = ph;
        this.scale = scale;
        this.maxIter = maxIter;
        this.name = name;
        this.format = format;
        this.maxTotalCount = maxTotalCount;
        this.nThreads = nThreads;

        try {
            System.out.println("Cargando imagen temporal");
            image = Utils.loadCompressed(name);
        } catch (Exception e) {
            System.out.println("Imagen temporal no existe");
            image = new int[pw][ph];
        }

        pixelWidth = scale / pw;
        minX = (-pw / 1.45) * pixelWidth;
        minY = (-ph / 2) * pixelWidth;

        System.out.println("MinX: " + minX + ", MinY: " + minY + ", PixelWidth: " + pixelWidth);
        double width = pw * pixelWidth;
        double height = ph * pixelWidth;

        maxX = minX + width;
        maxY = minY + height;

        System.out.println("Width: " + width + ", Height: " + height);
        System.out.println("MaxIter: " + maxIter);

        BuddhabrotComputingThread[] bcts = new BuddhabrotComputingThread[nThreads];

        for (int i = 0 ; i < nThreads ; i++) {
            bcts[i] = new BuddhabrotComputingThread(minX, minY, maxIter, pixelWidth, image);
            bcts[i].start();
        }

        for (int saves = 0 ; saves < 10000 ; saves++) {
            for (int i = 0 ; i < nThreads ; i++) {
                bcts[i].setPaused(false);
            }

            System.out.println("Calculando...");
            Utils.delay((long)(30 * 1000));

            for (int i = 0 ; i < nThreads ; i++) {
                bcts[i].setPaused(true);
            }
            Utils.delay(1000);

            long totalCount = Utils.computeTotalCount(image);
            System.out.println("Total Count: " + totalCount);

            System.out.println("Grabando RAW");
            try {
                Utils.saveCompressed(name, image);
            } catch (Exception ex) {
                Logger.getLogger(BuddhabrotPoster.class.getName()).log(Level.SEVERE, null, ex);
            }

        }

        for (int i = 0 ; i < nThreads ; i++) {
            bcts[i].exit();
            bcts[i].setPaused(false);
        }
        
        Utils.delay(1000);

    }










    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        System.out.println("java -cp dist/Buddhabrot.jar buddhabrot.BuddhabrotPoster nombre alto ancho iters maxTotalCount format nThreads");

        String name = args[0];
        int ancho = Integer.parseInt(args[1]);
        int alto = Integer.parseInt(args[2]);
        int iters = Integer.parseInt(args[3]);
        long maxTotalCount = Long.parseLong(args[4]);
        String format = args[5];
        int nThreads = Integer.parseInt(args[6]);
        
        // 3.3 escala

        BuddhabrotPoster bb = new BuddhabrotPoster(ancho, alto, 2, iters, name, format, maxTotalCount, nThreads);
    }
}
