/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package buddhabrot;

import java.awt.image.BufferedImage;
import java.awt.image.WritableRaster;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;

/**
 *
 * @author zerjillo
 */
public class Troceado {

    public static void main(String[] args) {
                double pixelWidth = 0.001;
                
        double minX = -2 + 1490 * pixelWidth;
        double minY = -1;

        int width = 1500;
        int height = 1000;
        int maxIter = 5000;
        String name = "mec2";

        int[][] image = new int[width][height];


        BuddhabrotComputingThread bcts = new BuddhabrotComputingThread(minX, minY, maxIter, pixelWidth, image);
        bcts.start();

        bcts.setPaused(false);
        
        System.out.println("Calculando...");
        Utils.delay((long) (30 * 1000));

        bcts.setPaused(true);

        Utils.delay(1000);

        long totalCount = Utils.computeTotalCount(image);
        System.out.println("Total Count: " + totalCount);

        System.out.println("Grabando RAW");
        try {
            Utils.saveCompressed(name, image);
        } catch (Exception ex) {
            ex.printStackTrace();
            System.exit(-1);
        }

        int max = Utils.getMax(image);

        System.out.println("Max: " + max);

        BufferedImage imageGray = new BufferedImage(width, height, BufferedImage.TYPE_USHORT_GRAY);
        WritableRaster r = (WritableRaster) imageGray.getData();

        for (int x = 0 ; x < width ; x++) {
            for (int y = 0 ; y < height ; y++) {
                r.setSample(x, y, 0, image[x][y] * 65535 / max);
            }
        }

        imageGray.setData(r);


        try {
            System.out.println("Saving");
            
            ImageIO.write(imageGray, "PNG", new File(name + ".png"));

        } catch (IOException e) {
            e.printStackTrace();
        }
        
        
        bcts.exit();
        bcts.setPaused(false);

        Utils.delay(1000);
    }
}
